# std::set<Key,Compare,Allocator>::clear

From cppreference.com
< cpp‎ | container‎ | set

void clear(); |  | (noexcept since C++11)

Erases all elements from the container. After this call, size() returns zero.

Invalidates any references, pointers, and iterators referring to contained elements. Any past-the-end iterator remains valid.

### Parameters

(none)

### Return value

(none)

### Complexity

Linear in the size of the container, i.e., the number of elements.

### Example

Run this code

    #include <iostream>
    #include <string_view>
    #include <set>

    void print_info(std::string_view rem, const std::set<int>& v)
    {
        std::cout << rem << "{ ";
        for (const auto& value : v)
            std::cout << value << ' ';
        std::cout << "}\n";
        std::cout << "Size=" << v.size() << '\n';
    }

    int main()
    {
        std::set<int> container{1, 2, 3};
        print_info("Before clear: ", container);
        container.clear();
        print_info("After clear: ", container);
    }

Output:

    Before clear: { 1 2 3 }
    Size=3
    After clear: { }
    Size=0

### Defect reports

The following behavior-changing defect reports were applied retroactively to previously published C++ standards.

DR | Applied to | Behavior as published | Correct behavior
--- | --- | --- | ---
LWG 224 | C++98 | the complexity was log(size()) + N, but N was not defined | corrected to 'linear in size()'

### See also

erase | erases elements (public member function)

Retrieved from "https://en.cppreference.com/mwiki/index.php?title=cpp/container/set/clear&oldid=135446"